//---------------------------------------------------------------------------

#ifndef FormMainH
#define FormMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>

#include "Settings.h"
#include <Menus.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <ComCtrls.hpp>
#include <CheckLst.hpp>
#include <Grids.hpp>
#include <ExtCtrls.hpp>
#include <vector>

//---------------------------------------------------------------------------
class TfrmMain : public TForm
{
__published:	// IDE-managed Components
	TStatusBar *StatusBar;
	TStringGrid *Grid;
	TPanel *pnlTop;
	TComboBox *cbLpt;
	TButton *btnOpen;
	TButton *btnClose;
	TMainMenu *MainMenu;
	TMenuItem *miFile;
	TMenuItem *miView;
	TMenuItem *miViewLog;
	TMenuItem *miSettings;
	TMenuItem *miCommonSettings;
	TMenuItem *miHelp;
	TMenuItem *miAbout;
	TActionList *ActionList;
	TAction *actShowAbout;
	TAction *actShowSettings;
	TAction *actShowLog;
	TImageList *imglistActions;
	TLabel *lblStepTime;
	TEdit *edStepPeriod;
	TLabel *lblMs;
	TButton *btnStart;
	TButton *btnStop;
	TLabel *lblCurrentPosition;
	TLabel *lblCurrentPositionVal;
	TLabel *lblRows;
	TEdit *edRowsCount;
	TButton *btnSetRowsCount;
	TTimer *tmrStartup;
	TTimer *tmrUpdatePosition;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall actShowAboutExecute(TObject *Sender);
	void __fastcall actShowSettingsExecute(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall actShowLogExecute(TObject *Sender);
	void __fastcall btnOpenClick(TObject *Sender);
	void __fastcall btnCloseClick(TObject *Sender);
	void __fastcall GridDrawCell(TObject *Sender, int ACol, int ARow,
          TRect &Rect, TGridDrawState State);
	void __fastcall GridMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall GridKeyPress(TObject *Sender, char &Key);
	void __fastcall btnStartClick(TObject *Sender);
	void __fastcall btnStopClick(TObject *Sender);
	void __fastcall btnSetRowsCountClick(TObject *Sender);
	void __fastcall tmrStartupTimer(TObject *Sender);
	void __fastcall tmrUpdatePositionTimer(TObject *Sender);
private:	// User declarations
	friend void CALLBACK TimeProc(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2);
	Settings appSettings;
	HANDLE lpt;
	void ReportError(AnsiString caption);
	void SetStatus(char *lpData, ...);
	void SetBit(int pos, int bit, bool state);
	std::vector<unsigned char> pattern;
	void SetRowCount(int count);	
public:		// User declarations
	__fastcall TfrmMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmMain *frmMain;
//---------------------------------------------------------------------------
#endif
